
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>利用Java实现电子邮件的批量发送 / iVAN</title>

    <meta name="description" content="利用Java实现电子邮件的批量发送 JAVA MAIL是利用现有的邮件账户发送邮件的工具,比如说,我在网易注册一个邮箱账户,通过JAVA Mail的操控,我可以不亲自登录网易邮箱,让程序自动的使用网易邮箱发送邮件.这一机制被广泛的用在注册激活和垃圾邮件的发送等方面.进行下载,并将mail.jar添加到classpath即可.如果你使用的是JAVA EE SDK,则可以在C:glassfishv3glassfishmodulesmail.jar找到所需的jar包,同样需要添加的classpath. JAVA邮件发送的大致过程是这样的">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">利用Java实现电子邮件的批量发送</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>J<a href="http://www.51testing.com/html/76/n-248076.html" rel="external nofollow noreferrer">AVA</a></strong> MAIL是利用现有的邮件账户发送邮件的工具，比如说，我在网易注册一个邮箱账户，通过JAVA Mail的操控，我可以不亲自登录网易邮箱，让程序自动的使用网易邮箱发送邮件。这一机制被广泛的用在注册激活和垃圾邮件的发送等方面。进行下载，并将mail.jar添加到classpath即可。如果你使用的是JAVA EE SDK，则可以在C：glassfishv3glassfishmodulesmail.jar找到所需的jar包，同样需要添加的classpath。</p>
<p>　　JAVA邮件发送的大致过程是这样的的：</p>
<p>　　1、构建一个继承自javax.mail.Authenticator的具体类，并重写里面的getPasswordAuthentication()方法。此类是用作登录校验的，以确保你对该邮箱有发送邮件的权利。</p>
<p>　　2、构建一个properties文件，该文件中存放SMTP服务器地址等参数。</p>
<p>　　3、通过构建的properties文件和javax.mail.Authenticator具体类来创建一个javax.mail.Session。Session的创建，就相当于登录邮箱一样。剩下的自然就是新建邮件。</p>
<p>　　4、构建邮件内容，一般是javax.mail.internet.MimeMessage对象，并指定发送人，收信人，主题，内容等等。</p>
<p>　　5、使用javax.mail.Transport工具类发送邮件。</p>
<p>　　下面是我封装的代码，注释也比较详细。呼呼~~</p>
<p>　　1、首先是继承自javax.mail.Authenticator的一个具体类。getPasswordAuthentication()方法也就是构建一个PasswordAuthentication对象并返回，有点费解JAVA Mail这样的设计意图，可能是javax.mail.Authenticator为我们提供了附加的保证安全的验证措施吧。</p>
<table>
<tbody>
<tr>
<td>
<ol>
<li><strong>package</strong> com.mzule.simplemail;  </li>
<li><strong>import</strong> javax.mail.Authenticator;  </li>
<li><strong>import</strong> javax.mail.PasswordAuthentication;  </li>
<li>/** </li>
<li>* 服务器邮箱登录验证 </li>
<li>* </li>
<li>* @author MZULE </li>
<li>* </li>
<li>*/ </li>
<li><strong>public</strong> <strong>class</strong> MailAuthenticator <strong>extends</strong> Authenticator {  </li>
<li>/** </li>
<li>* 用户名（登录邮箱） </li>
<li>*/ </li>
<li><strong>private</strong> String username;  </li>
<li>/** </li>
<li>* 密码 </li>
<li>*/ </li>
<li><strong>private</strong> String password;  </li>
<li>/** </li>
<li>* 初始化邮箱和密码 </li>
<li>* </li>
<li>* @param username 邮箱 </li>
<li>* @param password 密码 </li>
<li>*/ </li>
<li><strong>public</strong> MailAuthenticator(String username, String password) {  </li>
<li><strong>this</strong>.username = username;  </li>
<li><strong>this</strong>.password = password;  </li>
<li>}  </li>
<li>String getPassword() {  </li>
<li><strong>return</strong> password;  </li>
<li>}  </li>
<li>@Override </li>
<li><strong>protected</strong> PasswordAuthentication getPasswordAuthentication() {  </li>
<li><strong>return</strong> <strong>new</strong> PasswordAuthentication(username, password);  </li>
<li>}  </li>
<li>String getUsername() {  </li>
<li><strong>return</strong> username;  </li>
<li>}  </li>
<li><strong>public</strong> <strong>void</strong> setPassword(String password) {  </li>
<li><strong>this</strong>.password = password;  </li>
<li>}  </li>
<li><strong>public</strong> <strong>void</strong> setUsername(String username) {  </li>
<li><strong>this</strong>.username = username;  </li>
<li>}  </li>
<li>}</li>
</ol>
</td>
</tr>
</tbody>
</table>
<p>　2、邮件发送类，剩下的步骤都是在这个类实现的。代码中的SimpleMail是封装了邮件主题和内容的一个POJO。觉得在一个方法参数中既包含主题又包含内容，不太合适，故重载了此方法。还有就是因为大多数邮箱的SMTP服务器地址都是可以通过邮箱地址算出来，简单起见，提供了一个不需要SMTP服务器地址的构造器。</p>
<table>
<tbody>
<tr>
<td>
<ol>
<li><strong>package</strong> com.mzule.simplemail;  </li>
<li><strong>import</strong> java.util.List;  </li>
<li><strong>import</strong> java.util.Properties;  </li>
<li><strong>import</strong> javax.mail.MessagingException;  </li>
<li><strong>import</strong> javax.mail.Session;  </li>
<li><strong>import</strong> javax.mail.Transport;  </li>
<li><strong>import</strong> javax.mail.internet.AddressException;  </li>
<li><strong>import</strong> javax.mail.internet.InternetAddress;  </li>
<li><strong>import</strong> javax.mail.internet.MimeMessage;  </li>
<li><strong>import</strong> javax.mail.internet.MimeMessage.RecipientType;  </li>
<li>/**  </li>
<li>* 简单邮件发送器，可单发，群发。  </li>
<li>*  </li>
<li>* @author MZULE  </li>
<li>*  </li>
<li>*/ </li>
<li><strong>public</strong> <strong>class</strong> SimpleMailSender {  </li>
<li>/**  </li>
<li>* 发送邮件的props文件  </li>
<li>*/ </li>
<li><strong>private</strong> <strong>final</strong> <strong>transient</strong> Properties props = System.getProperties();  </li>
<li>/**  </li>
<li>* 邮件服务器登录验证  </li>
<li>*/ </li>
<li><strong>private</strong> <strong>transient</strong> MailAuthenticator authenticator;  </li>
<li>/**  </li>
<li>* 邮箱session  </li>
<li>*/ </li>
<li><strong>private</strong> <strong>transient</strong> Session session;  </li>
<li>/**  </li>
<li>* 初始化邮件发送器  </li>
<li>*  </li>
<li>* @param smtpHostName  </li>
<li>* SMTP邮件服务器地址  </li>
<li>* @param username  </li>
<li>* 发送邮件的用户名(地址)  </li>
<li>* @param password  </li>
<li>* 发送邮件的密码  </li>
<li>*/ </li>
<li><strong>public</strong> SimpleMailSender(<strong>final</strong> String smtpHostName, <strong>final</strong> String username,  </li>
<li><strong>final</strong> String password) {  </li>
<li>init(username, password, smtpHostName);  </li>
<li>}  </li>
<li>/**  </li>
<li>* 初始化邮件发送器  </li>
<li>*  </li>
<li>* @param username  </li>
<li>* 发送邮件的用户名(地址)，并以此解析SMTP服务器地址  </li>
<li>* @param password  </li>
<li>* 发送邮件的密码  </li>
<li>*/ </li>
<li><strong>public</strong> SimpleMailSender(<strong>final</strong> String username, <strong>final</strong> String password) {  </li>
<li>//通过邮箱地址解析出smtp服务器，对大多数邮箱都管用  </li>
<li><strong>final</strong> String smtpHostName = "smtp." + username.split("@")[1];  </li>
<li>init(username, password, smtpHostName);  </li>
<li>}  </li>
<li>/**  </li>
<li>* 初始化  </li>
<li>*  </li>
<li>* @param username  </li>
<li>* 发送邮件的用户名(地址)  </li>
<li>* @param password  </li>
<li>* 密码  </li>
<li>* @param smtpHostName  </li>
<li>* SMTP主机地址  </li>
<li>*/ </li>
<li><strong>private</strong> <strong>void</strong> init(String username, String password, String smtpHostName) {  </li>
<li>// 初始化props  </li>
<li>props.put("mail.smtp.auth", "true");  </li>
<li>props.put("mail.smtp.host", smtpHostName);  </li>
<li>// 验证  </li>
<li>authenticator = <strong>new</strong> MailAuthenticator(username, password);  </li>
<li>// 创建session  </li>
<li>session = Session.getInstance(props, authenticator);  </li>
<li>}  </li>
<li>/**  </li>
<li>* 发送邮件  </li>
<li>*  </li>
<li>* @param recipient  </li>
<li>* 收件人邮箱地址  </li>
<li>* @param subject  </li>
<li>* 邮件主题  </li>
<li>* @param content  </li>
<li>* 邮件内容  </li>
<li>* @throws AddressException  </li>
<li>* @throws MessagingException  </li>
<li>*/ </li>
<li><strong>public</strong> <strong>void</strong> send(String recipient, String subject, Object content)  </li>
<li><strong>throws</strong> AddressException, MessagingException {  </li>
<li>// 创建mime类型邮件  </li>
<li><strong>final</strong> MimeMessage message = <strong>new</strong> MimeMessage(session);  </li>
<li>// 设置发信人  </li>
<li>message.setFrom(<strong>new</strong> InternetAddress(authenticator.getUsername()));  </li>
<li>// 设置收件人  </li>
<li>message.setRecipient(RecipientType.TO, <strong>new</strong> InternetAddress(recipient));  </li>
<li>// 设置主题  </li>
<li>message.setSubject(subject);  </li>
<li>// 设置邮件内容  </li>
<li>message.setContent(content.toString(), "text/html;charset=utf-8");  </li>
<li>// 发送  </li>
<li>Transport.send(message);  </li>
<li>}  </li>
<li>/**  </li>
<li>* 群发邮件  </li>
<li>*  </li>
<li>* @param recipients  </li>
<li>* 收件人们  </li>
<li>* @param subject  </li>
<li>* 主题  </li>
<li>* @param content  </li>
<li>* 内容  </li>
<li>* @throws AddressException  </li>
<li>* @throws MessagingException  </li>
<li>*/ </li>
<li><strong>public</strong> <strong>void</strong> send(List&lt;String&gt; recipients, String subject, Object content)  </li>
<li><strong>throws</strong> AddressException, MessagingException {  </li>
<li>// 创建mime类型邮件  </li>
<li><strong>final</strong> MimeMessage message = <strong>new</strong> MimeMessage(session);  </li>
<li>// 设置发信人  </li>
<li>message.setFrom(<strong>new</strong> InternetAddress(authenticator.getUsername()));  </li>
<li>// 设置收件人们  </li>
<li><strong>final</strong> <strong>int</strong> num = recipients.size();  </li>
<li>　InternetAddress[] addresses = <strong>new</strong> InternetAddress[num];  </li>
<li><strong>for</strong> (<strong>int</strong> i = 0; i &lt;num; i++) {  </li>
<li>addresses[i] = <strong>new</strong> InternetAddress(recipients.get(i));  </li>
<li>}  </li>
<li>message.setRecipients(RecipientType.TO, addresses);  </li>
<li>// 设置主题  </li>
<li>message.setSubject(subject);  </li>
<li>// 设置邮件内容  </li>
<li>message.setContent(content.toString(), "text/html;charset=utf-8");  </li>
<li>// 发送  </li>
<li>Transport.send(message);  </li>
<li>}  </li>
<li>/**  </li>
<li>* 发送邮件  </li>
<li>*  </li>
<li>* @param recipient  </li>
<li>* 收件人邮箱地址  </li>
<li>* @param mail  </li>
<li>* 邮件对象  </li>
<li>* @throws AddressException  </li>
<li>* @throws MessagingException  </li>
<li>　*/ </li>
<li><strong>public</strong> <strong>void</strong> send(String recipient, SimpleMail mail)  </li>
<li><strong>throws</strong> AddressException, MessagingException {  </li>
<li>send(recipient, mail.getSubject(), mail.getContent());  </li>
<li>}  </li>
<li>/**  </li>
<li>* 群发邮件  </li>
<li>*  </li>
<li>* @param recipients  </li>
<li>* 收件人们  </li>
<li>* @param mail  </li>
<li>　* 邮件对  </li>
<li>　* @throws AddressException  </li>
<li>* @throws MessagingException  </li>
<li>*/ </li>
<li><strong>public</strong> <strong>void</strong> send(List&lt;String&gt; recipients, SimpleMail mail)  </li>
<li><strong>throws</strong> AddressException, MessagingException {  </li>
<li>send(recipients, mail.getSubject(), mail.getContent());  </li>
<li>}  </li>
<li>}</li>
</ol>
</td>
</tr>
</tbody>
</table>
<p>3、调用上面的邮箱发送器，可以构建一个工厂类，工厂类可以封装创建的过程，所以通过读配置文件获取邮箱用户名，密码都会变得十分方便。下面的代码是我在写观察者模式的时候写的，只是简单演示了工厂类。</p>
<table>
<tbody>
<tr>
<td>
<ol>
<li>　<strong>package</strong> com.mzule.dp.observer.factory;  </li>
<li><strong>import</strong> com.mzule.dp.observer.constant.MailSenderType;  </li>
<li><strong>import</strong> com.mzule.simplemail.SimpleMailSender;  </li>
<li>/**  </li>
<li>* 发件箱工厂  </li>
<li>*  </li>
<li>* @author MZULE  </li>
<li>*  </li>
<li>*/ </li>
<li><strong>public</strong> <strong>class</strong> MailSenderFactory {  </li>
<li>/**  </li>
<li>* 服务邮箱  </li>
<li>*/ </li>
<li><strong>private</strong> <strong>static</strong> SimpleMailSender serviceSms = <strong>null</strong>;  </li>
<li>/**  </li>
<li>* 获取邮箱  </li>
<li>*  </li>
<li>* @param type 邮箱类型  </li>
<li>* @return 符合类型的邮箱  </li>
<li>*/ </li>
<li><strong>public</strong> <strong>static</strong> SimpleMailSender getSender(MailSenderType type) {  </li>
<li><strong>if</strong> (type == MailSenderType.SERVICE) {  </li>
<li><strong>if</strong> (serviceSms == <strong>null</strong>) {  </li>
<li>serviceSms = <strong>new</strong> SimpleMailSender("invisible@126.com",  </li>
<li>"hidden");  </li>
<li>}  </li>
<li><strong>return</strong> serviceSms;  </li>
<li>}  </li>
<li><strong>return</strong> <strong>null</strong>;  </li>
<li>}  </li>
<li>}</li>
</ol>
</td>
</tr>
</tbody>
</table>
<p>　　4、发送邮件，还是观察者模式DEMO里面的代码，呼呼。</p>
<table>
<tbody>
<tr>
<td>
<ol>
<li><strong>package</strong> com.mzule.dp.observer.observer;  </li>
<li><strong>import</strong> java.util.ArrayList;  </li>
<li><strong>import</strong> java.util.List;  </li>
<li><strong>import</strong> java.util.Observable;  </li>
<li><strong>import</strong> java.util.Observer;  </li>
<li><strong>import</strong> javax.mail.MessagingException;  </li>
<li><strong>import</strong> javax.mail.internet.AddressException;  </li>
<li><strong>import</strong> com.mzule.dp.observer.constant.MailSenderType;  </li>
<li><strong>import</strong> com.mzule.dp.observer.factory.MailSenderFactory;  </li>
<li><strong>import</strong> com.mzule.dp.observer.po.Product;  </li>
<li><strong>import</strong> com.mzule.simplemail.SimpleMailSender;  </li>
<li><strong>public</strong> <strong>class</strong> ProductPriceObserver <strong>implements</strong> Observer {  </li>
<li>@Override </li>
<li><strong>public</strong> <strong>void</strong> update(Observable obj, Object arg) {  </li>
<li>Product product = <strong>null</strong>;  </li>
<li><strong>if</strong> (obj <strong>instanceof</strong> Product) {  </li>
<li>product = (Product) obj;  </li>
<li>}  </li>
<li><strong>if</strong> (arg <strong>instanceof</strong> Float) {  </li>
<li>Float price = (Float) arg;  </li>
<li>　Float decrease = product.getPrice() - price;  </li>
<li><strong>if</strong> (decrease &gt;0) {  </li>
<li>// 发送邮件  </li>
<li>SimpleMailSender sms = MailSenderFactory  </li>
<li>.getSender(MailSenderType.SERVICE);  </li>
<li>List&lt;String&gt; recipients = <strong>new</strong> ArrayList&lt;String&gt;();  </li>
<li>recipients.add("invisible@qq.com");  </li>
<li>recipients.add("invisible@gmail.com");  </li>
<li><strong>try</strong> {  </li>
<li><strong>for</strong> (String recipient : recipients) {  </li>
<li>sms.send(recipient, "价格变动", "您关注的物品" </li>
<li>+ product.getName() + "降价了，由" </li>
<li>+ product.getPrice() + "元降到" + price + "元，降幅达" </li>
<li>+ decrease + "元人民币。赶快购物吧。");  </li>
<li>}  </li>
<li>} <strong>catch</strong> (AddressException e) {  </li>
<li>e.printStackTrace();  </li>
<li>} <strong>catch</strong> (MessagingException e) {  </li>
<li>e.printStackTrace();  </li>
<li>}  </li>
<li>}  </li>
<li>}  </li>
<li>}  </li>
<li>}</li>
</ol>
</td>
</tr>
</tbody>
</table>
<p>本文出自seven的测试人生公众号最新内容请见作者的GitHub页：http://qaseven.github.io/</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-16 01:21:38</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/session/" title="session">session</a>, <a href="https://www.iamivan.net/tag/void/" title="void">void</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>利用Java实现电子邮件的批量发送的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/LzJYmVp.html" rel="bookmark">利用Java实现串口全双工通讯 &lpar;转载&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				利用Java实现串口全双工通讯 (投稿) Qingye Jiang (John)SMTH ID: qyjohnE-mail : qjiang@tsinghua.edu 一个嵌入式系统通常需要通过串口与其主控系统进行全双工通讯,譬如一个流水线控制系统需要不断的接受从主控系统发送来的查询和控制信息,并将执行结果或查询结果发送回主控系统.本文介绍了一个简单的通过串口实现全双工通讯的Java类库,该类库大大的简化了对串口进行操作的过程. 本类库主要包括:SerialBean.java (与其他应用程序的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5A8xBp.html" rel="bookmark">利用Java Beans在应用程序中创建组件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JavaBeans模块使开发人员能够创建称之为组件的软件单元(也就是我们熟知的beans).你可以把beans加载在更复杂的组件.Java小型应用程序(applets)或应用程序上.JavaBeans广泛应用于IDE应用程序,使你能够很容易地可视化组合组件并动态修改它的属性. Beans是动态的,允许你改变和定制它.在JavaBean Builder Tool里的设计模块中,你能利用 Bean的属性窗口来可视化定制和保存(持久)bean.你也可以从toolbox中选择一个bean,把它拖拽到窗体			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1loa3b.html" rel="bookmark">利用java socket 写的一个联机的五子棋游戏，服务器端和客户端的问题，大神求教啊。。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 利用java socket 写的一个联机的五子棋游戏,服务器端和客户端的问题,大神求教啊.. 利用java socket 写的一个联机的五子棋游戏,一个服务器端的程序和两个玩家的客户端程序,可不可以都运行在同一台主机上啊? 我运行服务器端和其中一个玩家的客户端程序时,正常.但是运行第二个玩家的客户端程序时,就出现了 Java.net.BindExecption Address already in use: JVM_Blind. 的异常.怎么办? 还有我打算客户端把下的棋子的对象传给服			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6GwJop.html" rel="bookmark">利用Java获取文件名、类名、方法名和行号的方法小结&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				大家都知道,在C语言中,我们可以通过宏FILE. __LINE__来获取文件名和行号,而在Java语言中,则可以通过StackTraceElement类来获取文件名.类名.方法名.行号,具体代码如下: public static int getLineNumber( ){ StackTraceElement[] stackTrace = new Throwable().getStackTrace(); return stackTrace[1].getLineNumber( ); } public			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNveWNM.html" rel="bookmark">利用java实现UDP（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 本帖子接&lt;利用java实现UDP&gt;这个帖子:客户端:UDPClientBean.javapackageUDPClient;importjava.io.*;importjava.net.*;classUDPClientBean{privateDatagramSocketdSocket;privateintServerPort;privateintClientPort;privateInetAddressServerIP;privateInetAddressClientIP;privat			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0Odajb.html" rel="bookmark">利用java实现UDP</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 网络课设作业,利用java来实现UDP,做了个小程序,第一次运行完全正确,等到第二次运行,就出现了问题,每次点&quot;发送&quot;按钮,都会停止在那里,没有错误提示,不知道是运算速度慢,结果还没出来,还是肿么一个情况,请大神给予解答哈--因每个帖子最多长度为10000个字符,所以分两个帖子发.呜呜呜--服务器端:UDPServerBean.javapackageUDPServer;importjava.io.*;importjava.net.*;publicclassUDPServerB			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/vMNmqdb.html" rel="bookmark">java struts2-怎样利用Java 中的struts2框架实现数据库中用户登录功能？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 怎样利用Java 中的struts2框架实现数据库中用户登录功能? 在Action中LoginAction怎样写? 配置文件中怎样写? 总体实现能够使数据库中已经存在的用户凭自己的密码与用户名登录成功呢?数据库是Oracle数据库.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/dzZxD6M.html" rel="bookmark">利用Java实现zip压缩&sol;解压缩</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				压缩 利用Java实现zip压缩/解压缩(作者: 2000年07月06日 13:30) 由于网络带宽有限,所以数据文件的压缩有利于数据在Internet上的快速传输,同时也节 省服务器的外存空间. Java 1.1实现了I/O数据流与网络数据流的单一接口,因此数据的压缩.网络传输和解 压缩的实现比较容易,下面介绍利用ZipEntry.ZipInputStream和ZipOutputStream三个Java 类实现zip数据压缩方式的编程方法. zip压缩文件结构:一个zip文件由多个entry组			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/2MW33rM.html" rel="bookmark">Php利用java解析xml</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				xml 作者: 雨伞首先如果你对JAVA不感兴趣或者说你的主机不支持JAVA或者你也不打算学习的话请不要浪费时间在这里. 请先安装JAVA的执行环境与PHP结合,具体参考http://www.phpx.com/happy/thr78795.html 或者下载http://www.javax.org/download/php_java.rar里面我写有个readme.txt说明文档,这个压缩包是个简单的例子. 要下载我的JAVA源码请到http://www.javax.org/download/J			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5odab.html" rel="bookmark" class="title">Win7应用程序如何在XP系统环境下运行</a>
					<div>
						  'Windows7系统应用程序如何在XP系统环境下能够正常运行'. 右击不能正常运行的程序,弹出的菜单点击&quot;属性&quot;命令 在出来的属性窗口单击&quot;兼容性&quot;选项卡 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VzwmknM.html" rel="bookmark" class="title">网页制作技巧之用CSS缩写给你的网站加速</a>
					<div>
						css|技巧|网页|网站加速 Web网站可用性的关键指标是速度,更确切地说,是页面能以多快的速度出现在访问者的浏览器窗口里.影响速度的因素有很多种,包括Web服务器的速度.访问者的Internet连接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/apX4LAp.html" rel="bookmark" class="title">ADO事件之&lpar;2&rpar;---EndOfRecordset &lpar;RecordsetEvent&rpar; 方法</a>
					<div>
						ado EndOfRecordset (RecordsetEvent) 方法 如果试图移动到超过 Recordset 结尾的行时,将调用 EndOfRecordset 方法. 语法 EndOfReco ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMq66Gp.html" rel="bookmark" class="title">如何设置前端服务器</a>
					<div>
						1. 安装本地配置存储 1) 在安装介质上浏览到 \setup\amd64\Setup.exe,然后单击&quot;确定&quot;. 2) 如果提示您安装 Microsoft Visual C++  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjJ6op.html" rel="bookmark" class="title">Sybase SQL remote更改传输断点的方法</a>
					<div>
						在sybase 的ASA与ASE数据库间通过SQL REMOTE传输数据经常会遇到传输日志点有误的现象. 一.通过翻译日志,并对照ASA.ASE的传输日志,确定正确的ASA发送点 1.在ASA中通过s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7knEKz.html" rel="bookmark" class="title">基于Eclipse 3&period;0的SWT编程</a>
					<div>
						一.SWT简介 Java语言的声望和它在桌面应用程序(GUI程序)所取得的成就显然极不相符,至今仍然很少能看到非常成功Java桌面程序.虽然有JBuilder,Netbean,JProbe等大型软件作 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo69l6z.html" rel="bookmark" class="title">Linux系统su&comma;passwd&comma;ls&comma;timestamp&comma;cd&comma;type及hash命令</a>
					<div>
						su的用法: switch user 用法 # su [-l] 用户名    []内可简写也就是不写. 更换密码 # passwd   打完回车  连写两次新密码就行,注意复杂程度****** com ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4QeNp.html" rel="bookmark" class="title">js复制网页内容并兼容各主流浏览器的代码</a>
					<div>
						 js 复制网页内容的方法代码有很多不过要兼容各浏览器就不多了,下面有个不错的方法,大家可以尝试操作下 因需要做一个js单击,复制当前网页url的功能.使用的是如下的方法,但是只能在ie浏览器下正常使 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYmNWM.html" rel="bookmark" class="title">win7开机启动项怎么设置</a>
					<div>
						  win7开机启动项怎么设置 如何不使用其他软件,直接设置或者修改开机启动的程序呢?其实操作系统就给我们提供了这个功能,网上的电脑管家之类的软件只不过方便一些而已.这里,我分享一下如何在win7里面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24a5op.html" rel="bookmark" class="title">如何节约Vista系统的硬盘空间？</a>
					<div>
						  Windows Vista安装后会占用很多硬盘空间,安装它至少要留20G的硬盘空间才可以正常使用,其实在安装好系统后,可通过关闭系统中一些没用的功能和文件,如系统的休眠功能.缩略图及系统还原等,来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJkZwqb.html" rel="bookmark" class="title">java web-javaweb图片异步上传问题</a>
					<div>
						问题描述 javaweb图片异步上传问题 有一个文章表,和一张图片表,一篇文章对应多张图片,在图片表中维护所属文章的id, 但在JSP中发布新的文章时,图片是异步上传(首先上传)的,等文章发布完成后, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kP9lM.html" rel="bookmark" class="title">基于阿里的Node全栈之路（三）利用阿里云OSS实现前后端分离</a>
					<div>
						嘿嘿,上篇文章因为在火车上写的,偷懒了,心存愧疚,还是补发一篇吧! 这次嘞,我们聊聊开发上老生常谈的话题,前后端分离.在文章第一篇里,我用了一张我的架构图,这里我把关于OSS的这部分抽出来. 可以看到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQryjKM.html" rel="bookmark" class="title">一道算法基础题 uva1586</a>
					<div>
						问题描述 一道算法基础题 uva1586 题目链接在这儿 http://uva.onlinejudge.org/index.php?option=com_onlinejudge&amp;Itemid= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwRQ6M.html" rel="bookmark" class="title">Asp&period;Net Web API 2 官网菜鸟学习系列导航&lbrack;持续更新中&rsqb;</a>
					<div>
						原文:Asp.Net Web API 2 官网菜鸟学习系列导航[持续更新中] 前言 本来一直参见于微软官网进行学习的, 官网网址http://www.asp.net/web-api.出于自己想锻炼一下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjKVrM.html" rel="bookmark" class="title">人人拟上市 分拆游戏业务</a>
					<div>
						人人一直是国内备受年轻人欢迎的社交平台,能让我们跨出校园,为不同身份的人提供互动交流的平台.而近日,据消息人士披露,人人公司已向内部传达将分拆游戏业务的意愿,正式的分拆将在今年9月实现,而分拆之后,游 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeo34OM.html" rel="bookmark" class="title">html文本框时间控制格式</a>
					<div>
						问题描述 各位高手有一事相求:我想在html的文本框里控制用户的时间格式的输入,想让用户用这种格式输入__:__用户只能填把小时和分钟填在线上而且用户不能删除__:__这些符号且是24小时时间只要用户 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBPlqz.html" rel="bookmark" class="title">开发一个Linux调试器（四）：Elves和dwarves</a>
					<div>
						到目前为止,你已经偶尔听到了关于 dwarves.调试信息.一种无需解析就可以理解源码方式.今天我们会详细介绍源码级的调试信息,作为本指南后面部分使用它的准备. 系列文章索引 随着后面文章的发布,这些 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyexV5M.html" rel="bookmark" class="title">异常-jsp中response实验，为什么出不了结果</a>
					<div>
						问题描述 jsp中response实验,为什么出不了结果 inputnumber.jsp &lt;%@ page contentType=&quot;text/html;charset=utf-8&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyW0EJz.html" rel="bookmark" class="title">表格展示无限级分类&lpar;PHP版&rpar;</a>
					<div>
						表格展示无限级分类(PHP版) TreeTable是一个能把无限分类展现为表格形式的PHP类库插件,分类的层级表示为表格的列,分类的行数表格分类的总数.单元格显示分类名称. TreeTable通过对单 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmVy51z.html" rel="bookmark" class="title">jQuery基于排序功能实现上移、下移的方法&lowbar;jquery</a>
					<div>
						本文实例讲述了jQuery基于排序功能实现上移.下移的方法.分享给大家供大家参考,具体如下: 效果 思路, 跟相邻元素,互换sort. 前提是每一个元素都有自己的sort值,不为零. &lt;tr i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmRX01z.html" rel="bookmark" class="title">HTML 5从技术变成标准并逐步成为现实</a>
					<div>
						也激化了Web (网页)App与苹果模式的Native (本地)App的激烈交锋,作为网页App重要入口,浏览器因此走上争斗的风口浪尖. 近日,手机QQ浏览器举办HTML 5创新大赛吸引网页App开发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Y9yBz.html" rel="bookmark" class="title">android-activity弹出框背景变成了桌面</a>
					<div>
						问题描述 activity弹出框背景变成了桌面 小米手机弹出一个activity背景变成了桌面弹出框的样式是如图所示自定义的					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjo9VZM.html" rel="bookmark" class="title">信息基础设施三年行动：投资1&period;2万亿完善四重点</a>
					<div>
						12日,国家发改委.工信部印发了&lt;信息基础设施重大工程建设三年行动方案&gt;(下称&lt;方案&gt;). &lt;方案&gt;明确,2016年至2018年,投资1.2 万亿元,重点完善新一代 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mqg5q3z.html" rel="bookmark" class="title">内部链接是作为网站优化中的重中之重</a>
					<div>
						摘要: 相信广大站长们也知道,无论是什么样的网站,其内部链接都是必不可缺的,可能有部分刚入行的从业者会问内部链接是什么?其实内部链接是很好理解的,简单的来解释一下,内部链接 相信广大站长们也知道,无论 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bByw0dz.html" rel="bookmark" class="title">ios 嵌套html5网页，&amp;amp&semi;amp&semi;lt&semi;input type&equals;&amp;amp&semi;amp&semi;quot&semi;file&amp;amp&semi;amp&semi;quot&semi;&amp;amp&semi;amp&semi;gt&semi;。在ipad中选择打开相机照相后，页面刷新了</a>
					<div>
						问题描述 ios嵌套html5网页,&lt;inputtype=&quot;file&quot;&gt;.在ipad中选择打开相机照相后,页面刷新了.在ipad浏览器中直接浏览就可以获得图片,网页也不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPOrW8M.html" rel="bookmark" class="title">《Flappy Bird》八月重新上架添加多人模式</a>
					<div>
						图:&lt;http://www.aliyun.com/zixun/aggregation/2482.html&quot;&gt;Flappy Bird&gt;将重新上架添多人游戏模式 北京时间5月1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boOnw3b.html" rel="bookmark" class="title">宁夏移动：爱心包裹赠灾区</a>
					<div>
						5月12日,宁夏移动银川分公司兴庆区营业部向四川灾区寄去三件&quot;爱心包裹&quot;.爱心包裹是营业部全体团员自发捐赠的物品,希望能给灾区的孩子带去欢笑,带去希望.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLJwaAb.html" rel="bookmark" class="title">国际唱片协会屡诉屡败法院再判百度MP3搜索合法</a>
					<div>
						2010年1月22日下午,北京市第一中级人民法院宣布了国际唱片协会诉百度MP3侵权案的判决结果,国际唱片协会再次败诉.法院判定百度MP3搜索合法,并驳回包括环球唱片.索尼BMG(香港)及华纳唱片三家国 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmdJgDM.html" rel="bookmark" class="title">南非世界杯是章鱼保罗的 巴西世界杯是百度的</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 文/八卦科技 &quot;神奇的鱼 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M08RK7M.html" rel="bookmark" class="title">关于伪静态和真静态的一点心得</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 1.关于伪静态的用处 有些用户觉得 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
